unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

//Type
//  TFreeMyForm = procedure(FormPoint: Pointer);

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MyFormList : TList;
  end;

var
  Form1: TForm1;

implementation

Uses Unit2;

{$R *.dfm}

procedure FreeMyForm(FormPoint: Pointer);
begin
  Form1.MyFormList.Delete(Form1.MyFormList.IndexOf(FormPoint));
  ShowMessage(IntToStr(Form1.MyFormList.Count));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   MyFormList := TList.Create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   MyFormList.Free;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var i : integer;
begin
   for i := 0 to MyFormList.Count - 1 do begin
       if TForm2(MyFormList.Items[i]).TableName = ListBox1.Items.Strings[ListBox1.ItemIndex] then begin
          TForm2(MyFormList.Items[i]).BringToFront;
          exit;
       end;
   end;
   Form2 := TForm2.Create(Self);
   Form2.Caption := ListBox1.Items.Strings[ListBox1.ItemIndex];
   Form2.TableName := ListBox1.Items.Strings[ListBox1.ItemIndex];
   Form2.Show;
   MyFormList.Add(Form2);
   Form2.FreeMyForm := @FreeMyForm;
end;

end.
 